#include <bits/stdc++.h>

using namespace std;

int main()
{
     int t ;
    cin >> t  ;
    int n , k ;
    cin >> n >> k ;
    int a[n] ;
    for(int i=0 ; i<n ; i++){
        cin >> a[i] ;
    }
    if((n+k)%2!=0){
        cout << "NE" ;
        return 0 ;
    }
    sort(a,a+n) ;
    int tr=0 ;
    for(int i=0 ; i<n ; i++){
        if(a[i]>=tr){
            tr++ ;
        }
        else{
            tr-- ;
        }
    }
    if(tr==k){
        cout << "DA" << endl ;
        for(int i=0 ; i<n ; i++){
            cout << a[i] << " " ;
        }
    }
    else{
        cout << "NE" ;
        return 0 ;
    }
    return 0;
}